﻿using Styx.Helpers;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace KeepGhostWolf
{
    public class KGWSettings : Settings
    {
        private static KGWSettings _instance;

        public KGWSettings()
            : base(System.IO.Path.Combine(CharacterSettingsDirectory, "KGWSettings.xml"))
        {


        }
        public static KGWSettings Instance
        {
            get { return _instance ?? (_instance = new KGWSettings()); }
        }
        [Setting, Styx.Helpers.DefaultValue(false)]
        [Category("General")]
        [DisplayName("Use In Combat")]
        [Description("If Enabled, it will continue to cast Ghost Wolf form in combat.\nIf Disabled, it will pause during combat.")]
        public bool UseInCombat { get; set; }

        [Setting, Styx.Helpers.DefaultValue(false)]
        [Category("General")]
        [DisplayName("Use While Mounted")]
        [Description("If Enabled, it will use Ghost Wolf if you are mounted (for whatever reason).\nIf Disabled, it will not cast while mounted.")]
        public bool UseWhileMounted { get; set; }

    }
}
