﻿using Buddy.Coroutines;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace KeepGhostWolf
{
    public class KeepGhostWolf : HBPlugin
    {
        private Buddy.Coroutines.Coroutine _coroutine;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        const int GHOST_WOLF_SPELL = 2645;
        const int GHOST_WOLF_AURA = 45528;
        public override string Author { get { return "SpeshulK926"; } }
        public override string Name { get { return "Keep Ghost Wolf"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override string ButtonText { get { return "KGW Config..."; } }
        public override bool WantButton { get { return true; } }
        public override void OnButtonPress()
        {
            SettingsForm frm = new SettingsForm();
            frm.ShowDialog();
            KGWSettings.Instance.Save();
        }

        public override void Pulse()
        {
            if (_coroutine == null || _coroutine.IsFinished)
            {
                if (_coroutine != null)
                    debugLog("Keep Ghost Wolf Ended.  Restarting...");

                _coroutine = new Coroutine(async () => await MainCoroutine());
            }

            try
            {
                _coroutine.Resume();
            }

            catch (Exception ex)
            {
                debugLog(ex.Message);
            }
        }
        private async Task MainCoroutine()
        {
            while (true)
            {
                //debugLog("MainCoroutine()");
                //debugLog("!Me.HasAura(GHOST_WOLF_AURA): " + (!Me.HasAura(GHOST_WOLF_SPELL)));
                bool mountedCheck = (KGWSettings.Instance.UseWhileMounted || (!KGWSettings.Instance.UseWhileMounted && !Me.Mounted));
                bool combatCheck = (KGWSettings.Instance.UseInCombat || (!Me.Combat && !KGWSettings.Instance.UseInCombat));
                if (await Cast(GHOST_WOLF_SPELL, Colors.Blue, !Me.HasAura(GHOST_WOLF_SPELL) && combatCheck && mountedCheck, true))
                {
                    continue;
                }
                await Coroutine.Yield();
            }
        }
        public static void infoLog(string message, params object[] args)
        {
            Logging.Write(Colors.White, "[KGW] " + message, args);
        }
        public static void debugLog(string message, params object[] args)
        {
            Logging.WriteQuiet("[KGW] " + message, args);
        }

        /// <summary>
        /// Specifies the current target when casting spell and sleeps for lag
        /// </summary>
        /// <param name="Spell"></param>
        /// <param name="reqs"></param>
        /// <returns></returns>
        public static async Task<bool> Cast(int Spell, Color newColor, bool reqs = true, bool sleep = true)
        {
            if (!reqs)
            {
                return false;
            }

            if (!SpellManager.CanCast(WoWSpell.FromId(Spell))) //Should we check for if out currentTarget is moving? *Second false
                return false;
            if (!SpellManager.Cast(Spell, Me))
                return false;
            infoLog("^" + WoWSpell.FromId(Spell).Name, newColor);
            if (sleep)
            {
                await CommonCoroutines.SleepForLagDuration();
            }
            else
            {
                await Coroutine.Yield();
            }

            return true;
        }

    }
}
